// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package storkv

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// KVClient is the client API for KV service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type KVClient interface {
	Get(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error)
	Put(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error)
	SetAdd(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error)
	SetDel(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error)
	SetClear(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error)
	SetGet(ctx context.Context, in *Pair, opts ...grpc.CallOption) (KV_SetGetClient, error)
}

type kVClient struct {
	cc grpc.ClientConnInterface
}

func NewKVClient(cc grpc.ClientConnInterface) KVClient {
	return &kVClient{cc}
}

func (c *kVClient) Get(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error) {
	out := new(Pair)
	err := c.cc.Invoke(ctx, "/com.freeje.api.stor.kv.KV/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *kVClient) Put(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error) {
	out := new(Pair)
	err := c.cc.Invoke(ctx, "/com.freeje.api.stor.kv.KV/Put", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *kVClient) SetAdd(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error) {
	out := new(Pair)
	err := c.cc.Invoke(ctx, "/com.freeje.api.stor.kv.KV/SetAdd", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *kVClient) SetDel(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error) {
	out := new(Pair)
	err := c.cc.Invoke(ctx, "/com.freeje.api.stor.kv.KV/SetDel", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *kVClient) SetClear(ctx context.Context, in *Pair, opts ...grpc.CallOption) (*Pair, error) {
	out := new(Pair)
	err := c.cc.Invoke(ctx, "/com.freeje.api.stor.kv.KV/SetClear", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *kVClient) SetGet(ctx context.Context, in *Pair, opts ...grpc.CallOption) (KV_SetGetClient, error) {
	stream, err := c.cc.NewStream(ctx, &KV_ServiceDesc.Streams[0], "/com.freeje.api.stor.kv.KV/SetGet", opts...)
	if err != nil {
		return nil, err
	}
	x := &kVSetGetClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type KV_SetGetClient interface {
	Recv() (*Pair, error)
	grpc.ClientStream
}

type kVSetGetClient struct {
	grpc.ClientStream
}

func (x *kVSetGetClient) Recv() (*Pair, error) {
	m := new(Pair)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// KVServer is the server API for KV service.
// All implementations should embed UnimplementedKVServer
// for forward compatibility
type KVServer interface {
	Get(context.Context, *Pair) (*Pair, error)
	Put(context.Context, *Pair) (*Pair, error)
	SetAdd(context.Context, *Pair) (*Pair, error)
	SetDel(context.Context, *Pair) (*Pair, error)
	SetClear(context.Context, *Pair) (*Pair, error)
	SetGet(*Pair, KV_SetGetServer) error
}

// UnimplementedKVServer should be embedded to have forward compatible implementations.
type UnimplementedKVServer struct {
}

func (UnimplementedKVServer) Get(context.Context, *Pair) (*Pair, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedKVServer) Put(context.Context, *Pair) (*Pair, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Put not implemented")
}
func (UnimplementedKVServer) SetAdd(context.Context, *Pair) (*Pair, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetAdd not implemented")
}
func (UnimplementedKVServer) SetDel(context.Context, *Pair) (*Pair, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetDel not implemented")
}
func (UnimplementedKVServer) SetClear(context.Context, *Pair) (*Pair, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetClear not implemented")
}
func (UnimplementedKVServer) SetGet(*Pair, KV_SetGetServer) error {
	return status.Errorf(codes.Unimplemented, "method SetGet not implemented")
}

// UnsafeKVServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to KVServer will
// result in compilation errors.
type UnsafeKVServer interface {
	mustEmbedUnimplementedKVServer()
}

func RegisterKVServer(s grpc.ServiceRegistrar, srv KVServer) {
	s.RegisterService(&KV_ServiceDesc, srv)
}

func _KV_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Pair)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(KVServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.stor.kv.KV/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(KVServer).Get(ctx, req.(*Pair))
	}
	return interceptor(ctx, in, info, handler)
}

func _KV_Put_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Pair)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(KVServer).Put(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.stor.kv.KV/Put",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(KVServer).Put(ctx, req.(*Pair))
	}
	return interceptor(ctx, in, info, handler)
}

func _KV_SetAdd_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Pair)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(KVServer).SetAdd(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.stor.kv.KV/SetAdd",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(KVServer).SetAdd(ctx, req.(*Pair))
	}
	return interceptor(ctx, in, info, handler)
}

func _KV_SetDel_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Pair)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(KVServer).SetDel(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.stor.kv.KV/SetDel",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(KVServer).SetDel(ctx, req.(*Pair))
	}
	return interceptor(ctx, in, info, handler)
}

func _KV_SetClear_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Pair)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(KVServer).SetClear(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.stor.kv.KV/SetClear",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(KVServer).SetClear(ctx, req.(*Pair))
	}
	return interceptor(ctx, in, info, handler)
}

func _KV_SetGet_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Pair)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(KVServer).SetGet(m, &kVSetGetServer{stream})
}

type KV_SetGetServer interface {
	Send(*Pair) error
	grpc.ServerStream
}

type kVSetGetServer struct {
	grpc.ServerStream
}

func (x *kVSetGetServer) Send(m *Pair) error {
	return x.ServerStream.SendMsg(m)
}

// KV_ServiceDesc is the grpc.ServiceDesc for KV service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var KV_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.stor.kv.KV",
	HandlerType: (*KVServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Get",
			Handler:    _KV_Get_Handler,
		},
		{
			MethodName: "Put",
			Handler:    _KV_Put_Handler,
		},
		{
			MethodName: "SetAdd",
			Handler:    _KV_SetAdd_Handler,
		},
		{
			MethodName: "SetDel",
			Handler:    _KV_SetDel_Handler,
		},
		{
			MethodName: "SetClear",
			Handler:    _KV_SetClear_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "SetGet",
			Handler:       _KV_SetGet_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "stor/kv.proto",
}
